var currentsitesearch = {
  onLoad: function() {
    // initialization code
    this.initialized = true;
    this.strings = document.getElementById("currentsitesearch-strings");
    this.lastDomain = '';
    
    var addedEngineName='Current site'; 
    
    var ss = Cc["@mozilla.org/browser/search-service;1"]
               .getService(Ci.nsIBrowserSearchService);

    if (!ss.getEngineByName(addedEngineName)) {
	    try {
	      ss.addEngineWithDetails(
	      		addedEngineName, 
	      		"http://w-shadow.com/files/currentsitesearch16.ico", 
	      		"",
	      		"Search the current site with Google", 
	      		"GET", 
	      		"http://www.google.com/cse?q={searchTerms}&cx=000988176643045971993%3Aweck1fuykf8");
	      		
	    } catch(e) {
	      alert(e.message);
	    }
	}
    
    var addedEngine = ss.getEngineByName(addedEngineName);
    var origEngineObj = addedEngine.wrappedJSObject;

    origEngineObj._searchForm = "http://www.google.com/cse?&cx=000988176643045971993%3Aweck1fuykf8";
    origEngineObj.oldGetSubmission=origEngineObj.getSubmission;
    
    origEngineObj.getSubmission = function SRCH_ENG_getSubmission(aData, aResponseType) {
	    var currentDomain = currentsitesearch.getCurrentDomain();
	    
	    var mysub = this.oldGetSubmission(aData, aResponseType);
	    var url = mysub.uri.spec;
	    
	    if ( currentDomain ) {
		    
		    if ( currentDomain.match( /google\./ ) ) {
				currentDomain = currentsitesearch.lastDomain;
			}; 
		    
			if ('' != currentDomain) {
	    		//aData = aData + ' site:'+currentDomain;
	    		url = url + '&sitesearch='+currentDomain;
	    		currentsitesearch.lastDomain = currentDomain;
    		}
    		
    	}; 
	    
    	//return this.oldGetSubmission(aData, aResponseType);
    	mysub.uri.spec = url;
	    return mysub;
    };
  },
  
  getBrowserWindow : function() {
		var doc = content.document;  
		if (doc == null) {
			var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].
				  getService(Components.interfaces.nsIWindowMediator );
			doc = wm.getMostRecentWindow("navigator:browser").content.document;
		};
		return doc;
  },
  
  getCurrentUrl : function() {
	var doc = this.getBrowserWindow();
	var url = doc.location.href;
	return(url);
  },
  
  getCurrentDomain : function() {
	var url = this.getCurrentUrl();
	domain_name = url.match( /:\/\/([^\/:]+)/ );
	if (domain_name && domain_name[1]) {
		return domain_name[1];
	} else {
		return '';
	}
  }

};
window.addEventListener("load", function(e) { currentsitesearch.onLoad(e); }, false);
